<template>
    <div id="language-select">
        <multiselect
            v-model="selectedLocale"
            :options="options"
            label="language"
            :allowEmpty="false"
            :showLabels="false"
            :preselectFirst="true"
            trackBy="language_iso_code"
            deselectLabel=""
            selectLabel=""
            @update:model-value="emitValue()"
        ></multiselect>
    </div>
</template>

<script lang="ts" setup>
import { ref, onMounted, defineEmits } from 'vue';
import Multiselect from 'vue-multiselect';
import { useI18n } from 'vue-i18n';
import { storeFactory } from '@/main';

const options = ref([]) as any;
const selectedLocale = ref({}) as any;
const props = defineProps({
    context: Object,
});
const configStore = storeFactory.configStore;
const i18n = useI18n();

onMounted(() => {
    for (let i = 0; i < i18n.availableLocales.length; i++) {
        options.value.push(setLocaleInfo(i18n.availableLocales[i]));
    }
    setValue(configStore.locale);
    emitValue();
});

const setLocaleInfo = (locale: string) => {
    return {
        language: getTranslationByKey('language', locale),
        language_iso_code: `${getTranslationByKey('language_iso_code', locale)}`,
        flag: `${getTranslationByKey('flag', locale)}`,
    };
};

const getTranslationByKey = (key: string, locale: string) => {
    return i18n.getLocaleMessage(locale)[key];
};

const setValue = (locale: string) => {
    selectedLocale.value = setLocaleInfo(locale);
};

const emitValue = () => {
    props.context?.node.input(selectedLocale.value.language_iso_code, false);
};
</script>

<style>
#language-select {
    max-width: 221px;
}
</style>
